using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace MyAddin120
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("7C6249EC-2C9C-41F3-BCA4-C6237B80A43A"), ProgId("MyAddin120.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private AddinExpress.MSO.ADXOlExplorerCommandBar adxOlExplorerCommandBar1;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
        private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
        private AddinExpress.MSO.ADXOlExplorerCommandBar adxOlExplorerCommandBar2;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton2;

        private string myKey = "";
        private bool lastVisible = true;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOlExplorerCommandBar1 = new AddinExpress.MSO.ADXOlExplorerCommandBar(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            this.adxOlExplorerCommandBar2 = new AddinExpress.MSO.ADXOlExplorerCommandBar(this.components);
            this.adxCommandBarButton2 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            // 
            // adxOlExplorerCommandBar1
            // 
            this.adxOlExplorerCommandBar1.CommandBarName = "adxOlExplorerCommandBar1";
            this.adxOlExplorerCommandBar1.CommandBarTag = "db85ca50-12f5-4c66-b4c9-cebf625dd90f";
            this.adxOlExplorerCommandBar1.Controls.Add(this.adxCommandBarButton1);
            this.adxOlExplorerCommandBar1.Temporary = true;
            this.adxOlExplorerCommandBar1.UpdateCounter = 8;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "adxCommandBarButton1";
            this.adxCommandBarButton1.ControlTag = "c510dc0f-d935-484a-a48a-7fdae16c1511";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.Temporary = true;
            this.adxCommandBarButton1.UpdateCounter = 4;
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.CommandBarsUpdate += new System.EventHandler(this.adxOutlookEvents_CommandBarsUpdate);
            this.adxOutlookEvents.NewExplorer += new AddinExpress.MSO.ADXOlExplorer_EventHandler(this.adxOutlookEvents_NewExplorer);
            // 
            // adxOlExplorerCommandBar2
            // 
            this.adxOlExplorerCommandBar2.CommandBarName = "adxOlExplorerCommandBar2";
            this.adxOlExplorerCommandBar2.CommandBarTag = "e24cfa55-f24d-4e1b-8a8f-c007cb1f3a6e";
            this.adxOlExplorerCommandBar2.Controls.Add(this.adxCommandBarButton2);
            this.adxOlExplorerCommandBar2.Temporary = true;
            this.adxOlExplorerCommandBar2.UpdateCounter = 3;
            // 
            // adxCommandBarButton2
            // 
            this.adxCommandBarButton2.Caption = "adxCommandBarButton2";
            this.adxCommandBarButton2.ControlTag = "69f6f864-2a7c-4dbd-8655-3d6a910fac61";
            this.adxCommandBarButton2.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton2.Temporary = true;
            this.adxCommandBarButton2.UpdateCounter = 2;
            this.adxCommandBarButton2.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton2_Click);
            // 
            // AddinModule
            // 
            this.AddinName = "MyAddin120";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);
            this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinInitialize);
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void adxOutlookEvents_NewExplorer(object sender, object explorer)
        {
            System.Diagnostics.Debug.WriteLine("!!! NewExplorer. Toolbar.Visible = " + 
                adxOlExplorerCommandBar1.Visible.ToString());
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            Outlook.Explorers explorers = OutlookApp.Explorers;
            if (explorers.Count != 0)
            {
                System.Diagnostics.Debug.WriteLine("!!! AddinStartupComplete. Explorers.Count != 0");
                System.Diagnostics.Debug.WriteLine("!!! AddinStartupComplete. Toolbar.Visible = " + adxOlExplorerCommandBar1.Visible.ToString());
            }
            else
                System.Diagnostics.Debug.WriteLine("!!! AddinStartupComplete. Explorers.Count == 0");
            Marshal.ReleaseComObject(explorers);
        }

        private void AddinModule_AddinBeginShutdown(object sender, EventArgs e)
        {
            // At this time, the command bar component is already disconnected, 
            // and adxOlExplorerCommandBar1.IsConnected is false,
            // so the Visible property returns its design-time settings.
            // To write a correct value to the registry, you need to trace the 
            // toolbar visibility at run-time. See adxOutlookEvents_CommandBarsUpdate.
            System.Diagnostics.Debug.WriteLine("!!! AddinBeginShutdown. Writing 'Visible = " + 
                adxOlExplorerCommandBar1.Visible.ToString() + 
                "' to the registry");
            Microsoft.Win32.Registry.SetValue(myKey, "CommandBarVisible", lastVisible, Microsoft.Win32.RegistryValueKind.DWord);
        }

        private void AddinModule_AddinInitialize(object sender, EventArgs e)
        {
            string rootKey = "";
            if (this.RegisterForAllUsers)
                rootKey = "HKEY_LOCAL_MACHINE";
            else
                rootKey = "HKEY_CURRENT_USER";
            myKey = rootKey + "\\" + this.RegistryKey + "\\My";
            // At this time, the command bar component isn't connected yet, 
            // and adxOlExplorerCommandBar1.IsConnected is false,
            // so the Visible property returns its design-time settings
            bool visible = Convert.ToBoolean(
                Microsoft.Win32.Registry.GetValue(
                    myKey, "CommandBarVisible", adxOlExplorerCommandBar1.Visible)
                    );
            System.Diagnostics.Debug.WriteLine("!!! AddinInitialize. The initial setting is 'Visible = " + visible.ToString() + "'");
            if (!visible)
                this.adxOlExplorerCommandBar1.ItemTypes = AddinExpress.MSO.ADXOlExplorerItemTypes.olUnknownItem;
        }

        private void adxCommandBarButton2_Click(object sender)
        {
            this.adxOlExplorerCommandBar1.ItemTypes = AddinExpress.MSO.ADXOlExplorerItemTypes.olMailItem;
            this.adxOlExplorerCommandBar1.Enabled = true;
            this.adxOlExplorerCommandBar1.Visible = true;
        }

        private void adxOutlookEvents_CommandBarsUpdate(object sender, EventArgs e)
        {
            // At this time, the command bar component is connected, 
            // and adxOlExplorerCommandBar1.IsConnected is true,
            // so the Visible property reflects the actual state of the toolbar
            lastVisible = adxOlExplorerCommandBar1.Visible;
        }

    }
}

